<?php


if ( !class_exists('Stock_Notifier_Popup_Ajax') ) {
    class Stock_Notifier_Popup_Ajax {
        public function __construct(){
            add_action('wp_ajax_stock_notifier_popup_ajax',[ $this, 'active_woocommerce' ] );
        }
        public function active_woocommerce() {
            if ( isset( $_POST ) ) {
                $nonce = sanitize_text_field( $_POST['nonce_validation'] );
                if ( ! isset( $nonce ) || ! wp_verify_nonce( $nonce, 'stock_notifier_popup_ajax' ) ) {
                    wp_die( -1, 403 );
                }
                if ( ! current_user_can( 'manage_options' ) ) {
                    return false;
                }
                if ( ! is_user_logged_in() ) {
                    return false;
                }
                define('WP_ADMIN', TRUE);
                define('WP_NETWORK_ADMIN', TRUE); // Need for Multisite
                define('WP_USER_ADMIN', TRUE);
                $woocoomerce = ABSPATH . 'wp-content/plugins/woocommerce/woocommerce.php';
    
                if ( file_exists( $woocoomerce )) {
                    require_once ABSPATH . 'wp-load.php';
                    require_once ABSPATH . 'wp-admin/includes/admin.php';
                    require_once ABSPATH . 'wp-admin/includes/upgrade.php';
                    require_once ABSPATH . 'wp-admin/includes/plugin.php';
                    activate_plugin($woocoomerce);
                    wp_send_json(
                        [
                            'success'          => true,
                        ]
                    );
                } else {
                    require_once(ABSPATH . 'wp-admin/includes/plugin-install.php');
                    require_once(ABSPATH . 'wp-admin/includes/class-wp-upgrader.php');
                    require_once(ABSPATH . 'wp-admin/includes/class-wp-ajax-upgrader-skin.php');
                    require_once(ABSPATH . 'wp-admin/includes/class-plugin-upgrader.php');
                    // Get Plugin Info
                    $api = plugins_api(
                        'plugin_information',
                        array(
                            'slug' => 'woocommerce',
                            'fields' => array(
                                'short_description' => false,
                                'sections' => false,
                                'requires' => false,
                                'rating' => false,
                                'ratings' => false,
                                'downloaded' => false,
                                'last_updated' => false,
                                'added' => false,
                                'tags' => false,
                                'compatibility' => false,
                                'homepage' => false,
                                'donate_link' => false,
                            ),
                        )
                    );
                    $skin     = new WP_Ajax_Upgrader_Skin();
                    $upgrader = new Plugin_Upgrader($skin);
                    $upgrader->install($api->download_link);
                    activate_plugin($woocoomerce);
                    wp_send_json(
                        [
                            'success'          => true,
                        ]
                    );
                }
            }
            die();
        }
    }
    new Stock_Notifier_Popup_Ajax();
}
